//+------------------------------------------------------------------+
//|                                            Market_Open_Lines.mq4 |
//|                                    Copyright  2008, NuckingFuts |
//|                            Revisions to make version c by smjones|
//+------------------------------------------------------------------+

#property indicator_chart_window
#property copyright "Copyright  2008, NuckingFuts"
#property link      "www.forexfactory.com"

extern int     NumberOfBars = 500;
extern string  Note = "0 means Display all bars";

extern int     Sydney_Open    = 20;
extern int     Tokyo_Open     = 23;
extern int     Frank_Open     = 5;
extern int     London_Open    = 7;
extern int     London_Close   = 15;
extern int     NY_Open        = 11;

extern color   SydneyColor = Tomato;
extern color   TokyoColor = Magenta;
extern color   FrankColor = Lime;
extern color   LondonColor = Yellow;
extern color   NYColor = DeepSkyBlue;
extern int     LabelFontSize  = 12;

datetime       printonce = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	
	
	return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()

{
	string name;
   bool done;
   
   while ( true )
      {
         done = true;
         for ( int i=0; i<ObjectsTotal(); i++ )
	        {
	           name = ObjectName(i);
	           if ( StringSubstr(name,3,4) == "Open" )
	              ObjectDelete(name); 
	        
	        }           
         for ( int n=0; n<ObjectsTotal();n++ )
            {
               name = ObjectName(n);
               if ( StringSubstr(name,3,4) == "Open" )
                  done = false;
            }
         if ( done ) return(0);   
      }


	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   /* If period > 1hr, don't draw open lines */
   if (Period() > PERIOD_H1) return(0);
   
   double loc;
   string today;
   int limit, ihour;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   if ( NumberOfBars == 0 ) 
      NumberOfBars = Bars-counted_bars;
   limit=NumberOfBars; //Bars-counted_bars;
   
      
   for(int i=0; i<limit; i++)   
      {
         today = TimeToStr(iTime(Symbol(),60,i));
         ihour = TimeHour(iTime(Symbol(),60,i));
         
         if ( ihour == Sydney_Open && printonce != iTime(Symbol(),60,i) )
            {
               
               loc = iOpen(Symbol(),60,i);
               DrawOpenLine("SydOpen"+today,"Sydney Open",today,loc);
               printonce = iTime(Symbol(),60,i);
            }   
            
         if ( ihour == Tokyo_Open && printonce != iTime(Symbol(),60,i) )
            {   
               loc = iOpen(Symbol(),60,i);
               DrawOpenLine("TokOpen"+today,"Tokyo Open",today,loc);
               printonce = iTime(Symbol(),60,i);
            } 
            
         if ( ihour == Frank_Open && printonce != iTime(Symbol(),60,i))
            {   
               loc = iOpen(Symbol(),60,i);
               DrawOpenLine("FrkOpen"+today,"EURO Open",today,loc);
               printonce = iTime(Symbol(),60,i);
            } 
               
         if ( ihour == London_Open && printonce != iTime(Symbol(),60,i))
            {   
               loc = iOpen(Symbol(),60,i);
               DrawOpenLine("LonOpen"+today,"London Open",today,loc);
               printonce = iTime(Symbol(),60,i);
            } 
               
         if ( ihour == London_Close && printonce != iTime(Symbol(),60,i))
            {   
               loc = iOpen(Symbol(),60,i);
               DrawOpenLine("LoCOpen"+today,"London Close",today,loc);
               printonce = iTime(Symbol(),60,i);
            }
         
         if ( ihour == NY_Open && printonce != iTime(Symbol(),60,i))
            {   
               loc = iOpen(Symbol(),60,i);
               DrawOpenLine("NY_Open"+today,"NY Open",today,loc);
               printonce = iTime(Symbol(),60,i);
            } 
      }    

   return(0);
}
//+------------------------------------------------------------------+
void DrawOpenLine(string ObjName, string ObjText, string OpenTime,double n)
{
   /* Convert the open time string to datetime */
   datetime t = StrToTime(OpenTime);
   color Color = White;
   if ( StringSubstr(ObjName,0,2) == "Sy" ) Color = SydneyColor; 
   if ( StringSubstr(ObjName,0,2) == "To" ) Color = TokyoColor; 
   if ( StringSubstr(ObjName,0,2) == "Fr" ) Color = FrankColor; 
   if ( StringSubstr(ObjName,0,2) == "Lo" ) Color = LondonColor; 
   if ( StringSubstr(ObjName,0,2) == "NY" ) Color = NYColor; 
   
   /* Create the vertical open line */
   ObjectCreate(ObjName,OBJ_VLINE,0,t,n);//Open[n]);
   ObjectSet(ObjName,OBJPROP_BACK,true); 
   ObjectSet(ObjName,OBJPROP_COLOR,Color);
   ObjectSet(ObjName,OBJPROP_STYLE,STYLE_DOT);
     
   /* Draw the label object */
   ObjectCreate(ObjName+"_Label",OBJ_TEXT,0,t,n);
   ObjectSetText(ObjName+"_Label",ObjText,LabelFontSize);
   ObjectSet(ObjName+"_Label",OBJPROP_ANGLE,90);
   ObjectSet(ObjName+"_Label",OBJPROP_COLOR,Color);

   return(0);
}
//+------------------------------------------------------------------+

