//+-------------------------------------------------------------------+
//|                                    jiva's BB Stop auto-trader.mq4 |
//|                                  Copyright  2011, Steve Hopwood  |
//|                              http://www.hopwood3.freeserve.co.uk  |
//+-------------------------------------------------------------------+
#property copyright "Copyright  2009, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  up "Up"
#define  down "Down"
#define  none "None"
#define  both "Both"
#define  buy "Buy"
#define  sell "Sell"
#define  ranging "Ranging"
#define  confused "Confused, and so cannot trade"
#define  trending "Trending"
#define  opentrade "There is a trade open"
#define  stopped "Trading is stopped"
#define  d1openpriceline "Daily open price line"
#define  dailypivotline "Daily pivot line"

//Pending trade price line
#define  pendingpriceline "Pending price line"
//Hidden sl and tp lines. If UseStealth enabled, the bot will close trades on a touch/break of these lines.
//Each line is named with its appropriate prefix and the ticket number of the relevant trade
#define  TpPrefix "Tp"
#define  SlPrefix "Sl"

//George's average tick lines
#define  AverageTick "Average Tick"
#define  AverageTickDn "Average Tick Down"
#define  AverageTickUp "Average Tick Up"


//Defined constants from hanover. Thanks David
#define AUD 0
#define CAD 1
#define CHF 2
#define EUR 3
#define GBP 4
#define JPY 5
#define NZD 6
#define USD 7

#define M1  0
#define M5  1
#define M15 2
#define M30 3
#define H1  4
#define H4  5
#define D1  6
#define W1  7
#define MN  8

/*


Matt Kennel has provided the code for bool O_R_CheckForHistory(int ticket). Cheers Matt, You are a star.


Code for adding debugging Sleep
Alert("G");
int x = 0;
while (x == 0) Sleep(100);

Code for returning a value as pips. The example returns the range of the previous candle
   int PipDivisor = 1;
   if (Digits == 3 || Digits == 5) PipDivisor = 10;
   double CandleRange = ((High[1] - Low[1]) / Point) / PipDivisor;

Standard order loop code
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderSymbol() != Symbol() ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;

   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)


FUNCTIONS LIST
int init()
int start()

----Trading----

void LookForTradingOpportunities()
bool IsTradingAllowed()
bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
   void ModifyOrder(int ticket, double stop, double take)
void CountOpenTrades()
bool CloseTrade(int ticket)
void LookForTradeClosure()
bool CheckTradingTimes()
void CloseAllTrades()

----Hidden sl/tp---- Doubles up for pending trades-based ea's
void DrawPendingPriceLines()
void DeletePendingPriceLines()
void ReplaceMissingSlTpLines()
void DeleteOrphanTpSlLines()

----Matt's Order Reliable library code
bool O_R_CheckForHistory(int ticket) Cheers Matt, You are a star.
void O_R_Sleep(double mean_time, double max_time)

----Indicator readings----
void ReadIndicatorValues()
void CalculateDailyResult()

----Hanover module----
bool HanoverFilter(int type)
void SetUpArrays()
void CleanUpInputString()
int CalculateParamsPassed()
void ReadHanover()
int LoadRSvalues()  
double ReadStrength(string curr, string tf, int shift)

----Central Bank Intervention module----
bool CentralBankInterventionModule()
void StoreQuote()
bool CbiHedging(int type)
bool SetupHedgeTrade(int type, string comment, double lotsize, double price)
bool CbiCloseTrades(int type)


----Trade management module----
void TradeManagementModule()
void BreakEvenStopLoss()
void JumpingStopLoss() 
void HiddenTakeProfit()
void HiddenStopLoss()
void TrailingStopLoss()
void CandlestickTrailingStop()
void ReportError()

*/

extern string  gen="----General inputs----";
extern double  HalfLot=0.02;
extern double  QuarterLot=0.01;
extern bool    StopTrading=false;
extern bool    TradeLong=true;
extern bool    TradeShort=true;
extern int     TakeProfit=0;
extern int     StopLoss=0;
extern int     MagicNumber=0;
extern string  TradeComment="J";
extern bool    CriminalIsECN=false;
extern double  MaxSpread=120;
extern bool    CloseTradeOnOppositeSignal=true;
extern bool    CloseTradeOnFastTrendChange=true; //added code to close on Fast Trend Changing - GAH

//BB stop. Copied from the indi source code
extern string  bb="----BB stop inputs----";
extern string  fbb="Fast BB";
extern int     FastLength=90;      // Bollinger Bands Period. Set to zero to disable this filter
extern double  FastDeviation=2;    // SlowDeviation
extern string  sbb="Slow BB";
extern int     SlowLength=180;      // Bollinger Bands Period
extern double  SlowDeviation=2;    // SlowDeviation
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double         MoneyRisk=1.00; // Offset Factor
int            Signal=1;       // Display signals mode: 1-Signals & Stops; 0-only Stops; 2-only Signals;
int            Line=1;         // Display line mode: 0-no,1-yes  
int            Nbars=1000;
double         FastUpTrendSignal = -1;//Will have a positive value if there is a green dot up signal on the chart
double         FastDownTrendSignal = -1;//Will have a positive value if there is a red dot down signal on the chart
double         SlowUpTrendSignal = -1;//Will have a positive value if there is a green dot up signal on the chart
double         SlowDownTrendSignal = -1;//Will have a positive value if there is a red dot down signal on the chart
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//Hidden tp/sl inputs.
extern string  hts="----Stealth stop loss and take profit inputs----";
extern int     HiddenPips=10;//Added to the 'hard' sl and tp and used for closure calculations

extern string  hm="----Hanover module----";
extern bool    UseHanover=false;
extern string  ctf="Time frames";
//extern string  TimeFrames="M1,M5,M15,M30,H1,H4,D1,W1,MN";
extern string  TimeFrames="D1";
extern int     SlopeConfirmationCandles=0;
extern int     StrongThreshold=0;
extern int     WeakThreshold=0;
extern string  hof="Hanover output file";
extern string  OutputFile            = "Output---Recent Strength.CSV";
extern int     NumPoints=15;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Arrays etc
string         InputString;//All purpose string to pass to CleanUpInputString() to remove unwanted leading/trailing stuff
int            NoOfTimeFrames;//The number for timeframes inputted into the TimeFrames input
string         Tf[];//Holds the time frames inputted into the TimeFrames input
string         StrongWeak[];//Holds the pair that represents the strongest and weakest in each time frame
string         StrongestCcy[], WeakestCcy[];//Go on, take a guess
double         StrongVal[], PrevStrongVal[], WeakVal[], PrevWeakVal[];//Another guess?
string         ConstructedPair[];//Holds the pairs made out of the currencies
string         Ccy1, Ccy2;//First and second currency in the pair

//Variables copied from the Strength Alerts indi. int LoadRSvalues() came from this
int      dig, tmf, h, i, j, k;
string alrt[11];
double   RSvalue[8,9,99];   // [currency,timeframe,datapoint#]
                            // currency: 0=AUD, 1=CAD, 2=CHF, 3=EUR, 4=GBP, 5=JPY, 6=NZD, 7=USD
                            // timeframe: 0=M1, 1=M5, 2=M15, 3=M30, 4=H1, 5=H4, 6=D1, 7=W1, 8=MN
                         
string   ccy[8] = {"AUD","CAD","CHF","EUR","GBP","JPY","NZD","USD"};
string   tf[9]  = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
string   arr[11];

int      ReadBars;//Bot reads the output file when this != Bars   
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern string  cbi="----Central Bank Intervention module----";
extern bool    UseCBI=false;//Saves altering all the existing code conditionals.
extern string  am="astral method";//Tick table method
extern bool    UseAstral=true;//No particular reason for the default
extern int     TableSize=20;//No of ticks to store in the table. Indexed 0 - 19
extern string  gm="George method";//Moving average of ticks
extern bool    UseGeorge=false;//No particular reason for the default
extern int     Per=40;             //number of ticks to average
extern int     Channel_Delta=10;   //delta above and below the average to draw lines
extern color   Line_Color=Yellow;   //line color
extern string  ctb="Common to both";
extern int     Threshold=30;//Distance in pips between the market and the norm that indicates something big happening
extern bool    CloseOnCBI=false;//Close open trades
extern bool    HedgeOnCBI=true;//Hedge open trades
extern double  CbiHedgeLotMultiplier=4;//Multiplies the individual trade's lot size
extern bool    TradeOnCBI=true;//Send a new trade
extern int     TradeOnCbiTP=0;//Take profit
extern int     TradeOnCbiSL=50;//Stoploss
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double         TickTable[20]; // circular buffer to hold the ticks
int            tc = -1; // Tick counter. current position in table
int            is_filled = 0; // is the table full yet?
int            fill_check_counter = 0; // check if we have looped through the table once
double         PipMultiplier = 1.0; // needed to convert a price differenct into a pip value
double         TickDiff;//Difference between current quote and TableSize quotes ago
//Some Booleans to tell the bot what it has already done
bool           TakingEmergencyAction;//Will be true if TickDiff crosses the threshold
bool           TradeSent, HedgeSent, TradesClosed;
bool           HedgingInProgress;//So the bot knows it is dealing with a hedged situation
string         direction;//Holds the up/down comparison of the 1st and last ticks in the table

//George filter
int            number_of_ticks=0;
double         sum_of_ticks=0;
double         moving_average=0;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Morning & Evening Hours";
extern string  Trade_Hoursi= "Use 24 hour, local time clock";
extern string  Trade_Hours_M= "Morning Hours 0-12";
extern  int    start_hourm = 0;
extern  int    end_hourm = 12;
extern string  Trade_Hours_E= "Evening Hours 12-24";
extern  int    start_houre = 12;
extern  int    end_houre = 24;

//AllAVerages filter, requested by jiva
extern string  aal="----All averages inputs----";
extern bool    UseAA=false;
extern int     TimeFrame    =  0;
extern int     Price        =  0;
extern int     MA_Period    = 21;
extern int     MA_Shift     =  0;
extern int     MA_Method    =  6;
extern int     CandleShift  =  0;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//double         AaVal; //Not used in this EA
double         AaUp, AaDown;//Buffers 0 (val) 1 (up) and 3 (down)
string         AaDirection;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern string  tmm="----Trade management module----";
//Breakeven has to be enabled for JS and TS to work.
extern string  BE="Break even settings";
extern bool    BreakEven=true;
extern int     BreakEvenPips=20;
extern int     BreakEvenProfit=5;
extern string  cts="----Candlestick trailing stop----";
extern bool    UseCandlestickTrailingStop=false;
extern int     CstTimeFrame=0;//Defaults to current chart
extern int     CstTrailCandles=1;//Defaults to previous candle
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int            OldCstBars;//For candlestick ts
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern string  JSL="Jumping stop loss settings";
extern bool    JumpingStop=true;
extern int     JumpingStopPips=20;
extern string  TSL="Trailing stop loss settings";
extern bool    TrailingStop=false;
extern int     TrailingStopPips=20;

extern string  do="----Daily opening price line----";
extern bool    DrawOpenPriceLine=true;
extern color   OpenPriceLineColour=Yellow;

extern string  dp="----Daily daily pivot line----";
extern bool    DrawPivotPriceLine=true;
extern color   PivotPriceLineColour=Turquoise;

extern string  mis="----Odds and ends----";
extern bool    ShowManagementAlerts=true;
extern int     DisplayGapSize=30;


//Matt's O-R stuff
int 	         O_R_Setting_max_retries 	= 10;
double 	      O_R_Setting_sleep_time 		= 4.0; /* seconds */
double 	      O_R_Setting_sleep_max 		= 15.0; /* seconds */
int            RetryCount = 10;//Will make this number of attempts to get around the trade context busy error.

//Trading variables
int            TicketNo, OpenTrades;
bool           CanTradeThisPair;//Will be false when this pair fails the currency can only trade twice filter, or the balanced trade filter
bool           BuyOpen, SellOpen;
double         upl;//For keeping track of the upl of hedged positions

//Pending price inputs. Keeps things hidden from the crims
bool           PendingBuy, PendingSell;
double         PendingPrice, PendingStop, PendingTake;
datetime       PendingTime;
double         PendingCandleRange;
double         PendingRecreationCancelPips = 2;
//Hidden stops variables
double         HiddenStopLoss, HiddenTakeProfit;


//Date/Time
datetime       ConvertedStartTime;

//Trend detection
string         SlowTrend, FastTrend;

//Running total of trades
int            LossTrades, WinTrades;
double         OverallProfit;

//Misc
string         Gap, ScreenMessage;
int            OldBars;
string         PipDescription=" pips";
bool           ForceTradeClosure;



void DisplayUserFeedback()
{
   
   if (IsTesting() && !IsVisualMode()) return;

   ScreenMessage = "";
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Updates for this EA are to be found at http://www.stevehopwoodforex.com", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES|TIME_SECONDS), NL );
   /*
   //Code for time to bar-end display from Candle Time by Nick Bilak
   double i;
   int m,s,k;
   m=Time[0]+Period()*60-CurTime();
   i=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, m + " minutes " + s + " seconds left to bar end", NL);
   */
      
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);      
   if (TradeLong) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Taking long trades", NL);
   if (TradeShort) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Taking short trades", NL);
   if (!TradeLong && !TradeShort) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Both TradeLong and TradeShort are set to false", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Half lot size: ", HalfLot, " (Criminal's minimum lot size: ", MarketInfo(Symbol(), MODE_MINLOT), ")", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Quarter size: ", QuarterLot, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Take profit: ", TakeProfit, PipDescription,  NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Stop loss: ", StopLoss, PipDescription,  NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number: ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trade comment: ", TradeComment, NL);
   if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = true", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "CriminalIsECN = false", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "MaxSpread = ", MaxSpread, ": Spread = ", MarketInfo(Symbol(), MODE_SPREAD), NL, NL );
   
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);      
   
   
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading hours", NL);
   if (start_hourm == 0 && end_hourm == 12 && start_houre && end_houre == 24) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            24H trading", NL);
   else
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            start_hourm: ", DoubleToStr(start_hourm, 2), 
                      ": end_hourm: ", DoubleToStr(end_hourm, 2), NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            start_houre: ", DoubleToStr(start_houre, 2), 
                      ": end_houre: ", DoubleToStr(end_houre, 2), NL);
                      
   }//else
   
   
   //Trend
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   
   
   if (UseHanover)
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);      
      string now, then;         
      for (int cc = 0; cc < ArraySize(Tf); cc++)
      {
         double strength1 = ReadStrength(Ccy1, Tf[cc], 0);
         double strength2 = ReadStrength(Ccy2, Tf[cc], 0);
         if (SlopeConfirmationCandles > 0) 
         {
            double prevstrength1 = ReadStrength(Ccy1, Tf[cc], SlopeConfirmationCandles);
            now = StringConcatenate(": Shift ",SlopeConfirmationCandles, " = ", DoubleToStr(prevstrength1, 2));
            double prevstrength2 = ReadStrength(Ccy2, Tf[cc], SlopeConfirmationCandles);
            then = StringConcatenate(": Shift ", SlopeConfirmationCandles, " = ", DoubleToStr(prevstrength2, 2));
         }//if (SlopeCandles[cc] > 0) 
      
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "TF ", Tf[cc], 
                                           ": ", Ccy1, ": Now = ", DoubleToStr(strength1, 2),
                                           now,
                                           ": ", Ccy2, ": Now = ", DoubleToStr(strength2, 2),
                                           then,
                                           NL);
      }//for (int cc = 0; cc < ArraySize(Tf); cc++)
      if (StrongThreshold > 0 && WeakThreshold > 0)
      {
         bool tradeable = false;
         if (strength1 > StrongThreshold && strength2 < WeakThreshold)
         {
            ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Threshold: Can trade this pair long", NL);
            tradeable = true;
         }//if (strength1 > StrongThreshold && strength2 < WeakThreshold)
         
         if (strength2 > StrongThreshold && strength1 < WeakThreshold)
         {
            ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Threshold: Can trade this pair short", NL);
            tradeable = true;
         }//if (strength1 > StrongThreshold && strength2 < WeakThreshold)
         
         if (!tradeable) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Threshold: Cannot trade this pair yet", NL);
      }//if (StrongThreshold > 0 && WeakThreshold > 0)
      
   }//if (UseHanover)

   //Single moving average
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);   
   if (UseAA)
   {
      //ScreenMessage = StringConcatenate(ScreenMessage,Gap, "AA value ", AaVal, ": AA direction: ", AaDirection, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "AA direction: ", AaDirection, NL);
      
   }//if (UseAA)
   else ScreenMessage = StringConcatenate(ScreenMessage,Gap, "AllAverages filter is turned off", NL);

   
   //Running total of trades
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);   
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Results today. Wins: ", WinTrades, ": Losses ", LossTrades,
                                     ": P/L ", DoubleToStr(OverallProfit, 2), NL);
   
   //Central Bank Intervention
   if (UseCBI)
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);   
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Central Bank Intervention", NL);
      string actions = "        ";
      if (TradeOnCBI) actions = StringConcatenate(actions, "Taking new trade: ");
      if (HedgeOnCBI) actions = StringConcatenate(actions, "Hedging existing trades: ");
      if (CloseOnCBI) actions = StringConcatenate(actions, "Closing existing trades: ");
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, actions, NL);
      if (is_filled == 0) // table not full yet, so nothing to do
      { 
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "        ", "Filling Tick table. ", fill_check_counter, " of ", TableSize, " Ticks filled.");         
      }//if (is_filled == 0)
      else 
      {
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "        ", "Current tick difference: ", DoubleToStr(TickDiff, 1), ", Threshold: ", Threshold);
      }//else

   }//if (UseCBI)
   
   
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   
   if (BreakEven)
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Breakeven is set to ", BreakEvenPips, PipDescription);
      ScreenMessage = StringConcatenate(ScreenMessage,": BreakEvenProfit = ", BreakEvenProfit, PipDescription);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL); 
   }//if (BreakEven)

   if (UseCandlestickTrailingStop)
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Using candlestick trailing stop", NL);      
   }//if (UseCandlestickTrailingStop)
   
   if (JumpingStop)
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Jumping stop is set to ", JumpingStopPips, PipDescription);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);   
   }//if (JumpingStop)
   

   if (TrailingStop)
   {
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trailing stop is set to ", TrailingStopPips, PipDescription);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);   
   }//if (TrailingStop)


   
   
   Comment(ScreenMessage);


}//void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----

   //Adapt to x digit criminals
   int multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   if(Digits == 7) multiplier = 1000;   
   
   if (multiplier > 1) PipDescription = " points";
   
   TakeProfit*= multiplier;
   StopLoss*= multiplier;
   HiddenPips*= multiplier;
   TradeOnCbiTP*= multiplier;
   TradeOnCbiSL*= multiplier;
   
   BreakEvenPips*= multiplier;
   BreakEvenProfit*= multiplier;
   JumpingStopPips*= multiplier;
   TrailingStopPips*= multiplier;
   
   
   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }//if (DisplayGapSize >0)
   
   //Reset CriminIsECN if crim is IBFX and the punter does not know or, like me, keeps on forgetting
   string name = TerminalCompany();
   int ispart = StringFind(name, "IBFX", 0);
   if (ispart < 0) ispart = StringFind(name, "Interbank FX", 0);
   if (ispart > -1) CriminalIsECN = true;   
   
   /////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Hanover module
   //Set up the arrays
   if (UseHanover)
   {
      SetUpArrays();
      Ccy1 = StringSubstr(Symbol(), 0, 3);
      Ccy2 = StringSubstr(Symbol(), 3, 3);
      ReadBars = iBars(NULL, PERIOD_M1);//Don't need it again when start() triggers
      ReadHanover();
   }//if (UseHanover)
   /////////////////////////////////////////////////////////////////////////////////////////////////////////
   
   /////////////////////////////////////////////////////////////////////////////////////////////////////////
   //CBI module
   int ret = ArrayResize(TickTable, TableSize);
   if (ret == -1) {
      Alert("Error: Could not initialize tick table!\n");
   }
   
   if (Digits == 2 || Digits == 3) PipMultiplier = 100.0;
   else if (Digits == 4 || Digits == 5) PipMultiplier = 10000.0;
   /////////////////////////////////////////////////////////////////////////////////////////////////////////
   
   
   if (TradeComment == "") TradeComment = " ";
   OldBars = Bars;
   DisplayUserFeedback();
   
   //Call sq's show trades indi
   //iCustom(NULL, 0, "SQ_showTrades",Magic, 0,0);

   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
   ObjectDelete(d1openpriceline);
   ObjectDelete(dailypivotline);
   
//----
   return(0);
}

////////////////////////////////////////////////////////////////////////////////////////////////
//TRADE MANAGEMENT MODULE

void ReportError()
{
   //All purpose sl mod error reporter. Called when a sl mod fails
   
   int err=GetLastError();
      
   Alert(OrderTicket()," stop loss modification failed with error(",err,"): ",ErrorDescription(err));
   Print(OrderTicket()," stop loss modification failed with error(",err,"): ",ErrorDescription(err));      

}//void ReportError()



void BreakEvenStopLoss() // Move stop loss to breakeven
{

   double NewStop;
   bool result;
   bool modify=false;
   string LineName = SlPrefix + DoubleToStr(OrderTicket(), 0);
   double sl = ObjectGet(LineName, OBJPROP_PRICE1);
   
   if (OrderType()==OP_BUY)
   {
      if (sl >= OrderOpenPrice() ) return;
      if (Bid >= OrderOpenPrice () + (Point*BreakEvenPips))          
      {
         //Calculate the new stop
         NewStop = NormalizeDouble(OrderOpenPrice()+(BreakEvenProfit*Point), Digits);
         if (HiddenPips > 0)
         {
            if (ObjectFind(LineName) == -1)
            {
               ObjectCreate(LineName, OBJ_HLINE, 0, TimeCurrent(), 0);
               ObjectSet(LineName, OBJPROP_COLOR, Red);
               ObjectSet(LineName, OBJPROP_WIDTH, 1);
               ObjectSet(LineName, OBJPROP_STYLE, STYLE_DOT);
            }//if (ObjectFind(LineName == -1) )
         
            ObjectMove(LineName, 0, TimeCurrent(), NewStop);         
         }//if (HiddenPips > 0)
         modify = true;   
      }//if (Bid >= OrderOpenPrice () + (Point*BreakEvenPips) && 
   }//if (OrderType()==OP_BUY)               			         
    
   if (OrderType()==OP_SELL)
   {
     if (sl <= OrderOpenPrice() && sl > 0) return;
     if (Ask <= OrderOpenPrice() - (Point*BreakEvenPips)) 
     {
         //Calculate the new stop
         NewStop = NormalizeDouble(OrderOpenPrice()-(BreakEvenProfit*Point), Digits);
         if (HiddenPips > 0)
         {
            if (ObjectFind(LineName) == -1)
            {
               ObjectCreate(LineName, OBJ_HLINE, 0, TimeCurrent(), 0);
               ObjectSet(LineName, OBJPROP_COLOR, Red);
               ObjectSet(LineName, OBJPROP_WIDTH, 1);
               ObjectSet(LineName, OBJPROP_STYLE, STYLE_DOT);
            }//if (ObjectFind(LineName == -1) )
         
            ObjectMove(LineName, 0, Time[0], NewStop);
         }//if (HiddenPips > 0)         
         modify = true;   
     }//if (Ask <= OrderOpenPrice() - (Point*BreakEvenPips) && (OrderStopLoss()>OrderOpenPrice()|| OrderStopLoss()==0))     
   }//if (OrderType()==OP_SELL)

   //Move 'hard' stop loss whether hidden or not. Don't want to risk losing a breakeven through disconnect.
   if (modify && HiddenStopLoss > 0)
   {
      while (IsTradeContextBusy() ) Sleep(100);
      result = OrderModify(OrderTicket(), OrderOpenPrice(), NewStop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);      
      if (!result) ReportError();
   }//if (modify)
   
} // End BreakevenStopLoss sub

void JumpingStopLoss() 
{
   // Jump sl by pips and at intervals chosen by user .

   if (OrderProfit() < 0) return;//Nothing to do
   string LineName = SlPrefix + DoubleToStr(OrderTicket(), 0);
   double sl = ObjectGet(LineName, OBJPROP_PRICE1);
   if (sl == 0) return;//No line, so nothing to do
   double NewStop;
   bool modify=false;
   bool result;
   
   
   if (OrderType()==OP_BUY)
   {
      if (sl < OrderOpenPrice() ) return;//Not at breakeven yet
      // Increment sl by sl + JumpingStopPips.
      // This will happen when market price >= (sl + JumpingStopPips)
      if (Bid>= sl + ((JumpingStopPips*2)*Point) )
      {
         NewStop = NormalizeDouble(sl + (JumpingStopPips * Point), Digits);
         if (HiddenPips > 0) ObjectMove(LineName, 0, Time[0], NewStop);
         modify = true;   
      }// if (Bid>= sl + (JumpingStopPips*Point) && sl>= OrderOpenPrice())      
   }//if (OrderType()==OP_BUY)
   
   if (OrderType()==OP_SELL)
   {
      if (sl > OrderOpenPrice() ) return;//Not at breakeven yet
      // Decrement sl by sl - JumpingStopPips.
      // This will happen when market price <= (sl - JumpingStopPips)
      if (Bid<= sl - ((JumpingStopPips*2)*Point))
      {
         NewStop = NormalizeDouble(sl - (JumpingStopPips * Point), Digits);
         if (HiddenPips > 0) ObjectMove(LineName, 0, Time[0], NewStop);
         modify = true;   
      }// close if (Bid>= sl + (JumpingStopPips*Point) && sl>= OrderOpenPrice())         
   }//if (OrderType()==OP_SELL)

   //Move 'hard' stop loss whether hidden or not. Don't want to risk losing a breakeven through disconnect.
   if (modify && HiddenStopLoss > 0)
   {
      while (IsTradeContextBusy() ) Sleep(100);
      result = OrderModify(OrderTicket(), OrderOpenPrice(), NewStop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);      
      if (!result) ReportError();
   }//if (modify)

} //End of JumpingStopLoss sub


void TrailingStopLoss()
{
   
   if (OrderProfit() < 0) return;//Nothing to do
   string LineName = SlPrefix + DoubleToStr(OrderTicket(), 0);
   double sl = ObjectGet(LineName, OBJPROP_PRICE1);
   if (sl == 0) return;//No line, so nothing to do
   double NewStop;
   bool modify=false;
   bool result;
   
   if (OrderType()==OP_BUY)
   {
      if (sl < OrderOpenPrice() ) return;//Not at breakeven yet
      // Increment sl by sl + TrailingStopPips.
      // This will happen when market price >= (sl + JumpingStopPips)
      if (Bid>= sl + (TrailingStopPips * Point) )
      {
         NewStop = NormalizeDouble(sl + (TrailingStopPips * Point), Digits);
         if (HiddenPips > 0) ObjectMove(LineName, 0, Time[0], NewStop);
         modify = true;   
      }// if (Bid>= sl + (JumpingStopPips*Point) && sl>= OrderOpenPrice())      
   }//if (OrderType()==OP_BUY)
   
   if (OrderType()==OP_SELL)
   {
      if (sl > OrderOpenPrice() ) return;//Not at breakeven yet
      // Decrement sl by sl - TrailingStopPips.
      // This will happen when market price <= (sl - JumpingStopPips)
      if (Bid<= sl - (TrailingStopPips * Point) )
      {
         NewStop = NormalizeDouble(sl - (TrailingStopPips * Point), Digits);
         if (HiddenPips > 0) ObjectMove(LineName, 0, Time[0], NewStop);
         modify = true;   
      }// close if (Bid>= sl + (JumpingStopPips*Point) && sl>= OrderOpenPrice())         
   }//if (OrderType()==OP_SELL)

   //Move 'hard' stop loss whether hidden or not. Don't want to risk losing a breakeven through disconnect.
   if (modify && HiddenStopLoss > 0)
   {
      while (IsTradeContextBusy() ) Sleep(100);
      result = OrderModify(OrderTicket(), OrderOpenPrice(), NewStop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);      
      if (!result) ReportError();
   }//if (modify)
      
} // End of TrailingStopLoss sub

void CandlestickTrailingStop()
{
   
   //Trails the stop at the hi/lo of the previous candle shifted by the user choice.
   //Only tries to do this once per bar, so an invalid stop error will only be generated once. I could code for
   //a too-close sl, but cannot be arsed. Coders, sort this out for yourselves.
   
   if (OldCstBars == Bars) return;
   OldCstBars = Bars;

   if (OrderProfit() < 0) return;//Nothing to do
   string LineName = SlPrefix + DoubleToStr(OrderTicket(), 0);
   double sl = ObjectGet(LineName, OBJPROP_PRICE1);
   if (sl == 0) return;//No line, so nothing to do
   double NewStop;
   bool modify=false;
   bool result;
   

   if (OrderType() == OP_BUY)
   {
      if (iLow(NULL, CstTimeFrame, CstTrailCandles) > sl)
      {
         NewStop = NormalizeDouble(Low[1], Digits);
         if (HiddenPips > 0) ObjectMove(LineName, 0, Time[0], NewStop);
         modify = true;   
      }//if (iLow(NULL, CstTimeFrame, CstTrailCandles) > sl)
   }//if (OrderType == OP_BUY)
   
   if (OrderType() == OP_SELL)
   {
      if (iHigh(NULL, CstTimeFrame, CstTrailCandles) < sl)
      {
         NewStop = NormalizeDouble(High[1], Digits);
         if (HiddenPips > 0) ObjectMove(LineName, 0, Time[0], NewStop);
         modify = true;   
      }//if (iHigh(NULL, CstTimeFrame, CstTrailCandles) < sl)
   }//if (OrderType() == OP_SELL)
   
   //Move 'hard' stop loss whether hidden or not. Don't want to risk losing a breakeven through disconnect.
   if (modify && HiddenStopLoss > 0)
   {
      while (IsTradeContextBusy() ) Sleep(100);
      result = OrderModify(OrderTicket(), OrderOpenPrice(), NewStop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);      
      if (!result) ReportError();
   }//if (modify)

}//End void CandlestickTrailingStop()

void TradeManagementModule()
{

   // Call the working subroutines one by one. 

   //Candlestick trailing stop
   if (UseCandlestickTrailingStop) CandlestickTrailingStop();


   // Breakeven
   if(BreakEven) BreakEvenStopLoss();

   // JumpingStop
   if(JumpingStop) JumpingStopLoss();

   //TrailingStop
   if(TrailingStop) TrailingStopLoss();

   

}//void TradeManagementModule()
//END TRADE MANAGEMENT MODULE
////////////////////////////////////////////////////////////////////////////////////////////////

bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
{
   //pah (Paul) contributed the code to get around the trade context busy error. Many thanks, Paul.
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   //For CBI module. Set to true if the module detects a massive move
   if (TakingEmergencyAction) slippage = 1000;
   
   color col = Red;
   if (type == OP_BUY || type == OP_BUYSTOP) col = Green;
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);

   //RetryCount is declared as 10 in the Trading variables section at the top of this file
   for (int cc = 0; cc < RetryCount; cc++)
   {
      for (int d = 0; (d < RetryCount) && IsTradeContextBusy(); d++) Sleep(100);

      RefreshRates();
      if (type == OP_BUY) price = NormalizeDouble(Ask, Digits);
      if (type == OP_SELL) price = NormalizeDouble(Bid, Digits);
      
      if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, expiry, col);
   
   
      //Is a 2 stage criminal
      if (CriminalIsECN)
      {
         ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, MagicNumber, expiry, col);
         if (ticket > -1)
         {
	           ModifyOrder(ticket, stop, take);
         }//if (ticket > 0)}
      }//if (CriminalIsECN)
      
      if (ticket > -1) break;//Exit the trade send loop
      if (cc == RetryCount - 1) return(false);
   
      //Error trapping for both
      if (ticket < 0)
      {
         string stype;
         if (type == OP_BUY) stype = "OP_BUY";
         if (type == OP_SELL) stype = "OP_SELL";
         if (type == OP_BUYLIMIT) stype = "OP_BUYLIMIT";
         if (type == OP_SELLLIMIT) stype = "OP_SELLLIMIT";
         if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
         if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
         int err=GetLastError();
         Alert(Symbol(), " ", WindowExpertName(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
         Print(Symbol(), " ", WindowExpertName(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
         return(false);
      }//if (ticket < 0)  
   }//for (int cc = 0; cc < RetryCount; cc++);
   
   
   TicketNo = ticket;
   //Make sure the trade has appeared in the platform's history to avoid duplicate trades.
   //My mod of Matt's code attempts to overcome the bastard crim's attempts to overcome Matt's code.
   bool TradeReturnedFromCriminal = false;
   while (!TradeReturnedFromCriminal)
   {
      TradeReturnedFromCriminal = O_R_CheckForHistory(ticket);
      if (!TradeReturnedFromCriminal)
      {
         Alert(Symbol(), " sent trade not in your trade history yet. Turn of this ea NOW.");
      }//if (!TradeReturnedFromCriminal)
   }//while (!TradeReturnedFromCriminal)
   
   //Got this far, so trade send succeeded
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)

void ModifyOrder(int ticket, double stop, double take)
{
   //Modifies an order already sent if the crim is ECN.
 
   if (stop == 0 && take == 0) return; //nothing to do
 
   if (!OrderSelect(ticket, SELECT_BY_TICKET) ) return;//Trade does not exist, so no mod needed
   
   //RetryCount is declared as 10 in the Trading variables section at the top of this file   
   for (int cc = 0; cc < RetryCount; cc++)
   {
      for (int d = 0; (d < RetryCount) && IsTradeContextBusy(); d++) Sleep(100);
        if (take > 0 && stop > 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           if (OrderModify(ticket, OrderOpenPrice(), stop, take, OrderExpiration(), CLR_NONE)) return;           
        }//if (take > 0 && stop > 0)
   
        if (take != 0 && stop == 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           if (OrderModify(ticket, OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE)) return;
        }//if (take == 0 && stop != 0)

        if (take == 0 && stop != 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           if (OrderModify(ticket, OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE)) return;
        }//if (take == 0 && stop != 0)
   }//for (int cc = 0; cc < RetryCount; cc++)
   
   //Got this far, so the order modify failed
   int err=GetLastError();
   Print(Symbol(), " SL/TP  order modify failed with error(",err,"): ",ErrorDescription(err));               
   Alert(Symbol(), " SL/TP  order modify failed with error(",err,"): ",ErrorDescription(err));               

}//void ModifyOrder(int ticket, double tp, double sl)



bool IsTradingAllowed()
{
   //Returns false if any of the filters should cancel trading, else returns true to allow trading
   
      
   //Maximum spread
   if (MarketInfo(Symbol(), MODE_SPREAD) > MaxSpread) return(false);
 
 
   
   
   return(true);


}//End bool IsTradingAllowed()


void LookForTradingOpportunities()
{


   RefreshRates();
   double take, stop, price;
   int type;
   bool SendTrade;

   double SendLots = HalfLot;//Initialise with a default value
   
   //Using Recovery
   //Check filters
   if (!IsTradingAllowed() ) return;
   
   //Set up some variables to tell jiva which trade to send
   bool SendLong = false, SendShort = false;
   
   //Decide which trade to send, if any
   //Initial buy
   if (SlowTrend == up && OpenTrades == 0)
   {
      SendLong = true;   
   }//if (SlowTrend == up && OpenTrades == 0)
   
   //Secondary buys
   if (FastTrend == up && OpenTrades < 3 && BuyOpen)
   {
      SendLong = true;
      SendLots = QuarterLot;
   }//if (FastTrend == up && OpenTrades < 3)
   
   //Initial sell
   if (SlowTrend == down && OpenTrades == 0)
   {
      SendShort = true;   
   }//if (SlowTrend == down && OpenTrades == 0)
   
   //Secondary sells
   if (FastTrend == down && OpenTrades < 3 && SellOpen)
   {
      SendShort = true;
      SendLots = QuarterLot;   
   }//if (FastTrend == down && OpenTrades < 3)
   
   
   //Long 
   if (SendLong)
   {
      if (!TradeLong) return;
   
      //AA
      if (UseAA && AaDirection != up) return;
      
      //Hanover RS
      if (UseHanover && !HanoverFilter(OP_BUY) ) return(false);
   
      if (TakeProfit > 0) 
      {
         take = NormalizeDouble(Ask + (TakeProfit * Point), Digits);
         HiddenTakeProfit = take;
         if (HiddenPips > 0) take = NormalizeDouble(take + (HiddenPips * Point), Digits);
      }//if (TakeProfit > 0) 
      
      if (StopLoss > 0) 
      {
         stop = NormalizeDouble(Ask - (StopLoss * Point), Digits);
         HiddenStopLoss = stop;
         if (HiddenPips > 0) stop = NormalizeDouble(stop - (HiddenPips * Point), Digits);
      }//if (StopLoss > 0) 
      
      type = OP_BUY;
      price = Ask;
      SendTrade = true;
   }//if (SendLong)
   
   
   //Short
   if (SendShort)
   {
      if (!TradeShort) return;
      
      //AA
      if (UseAA && AaDirection != down) return;
      

      //Hanover RS
      if (UseHanover && !HanoverFilter(OP_SELL) ) return(false);

      if (TakeProfit > 0) 
      {
         take = NormalizeDouble(Bid - (TakeProfit * Point), Digits);
         HiddenTakeProfit = take;
         if (HiddenPips > 0) take = NormalizeDouble(take - (HiddenPips * Point), Digits);
      }//if (TakeProfit > 0) 
      
      if (StopLoss > 0) 
      {
         stop = NormalizeDouble(Bid + (StopLoss * Point), Digits);
         HiddenStopLoss = stop;
         if (HiddenPips > 0) stop = NormalizeDouble(stop + (HiddenPips * Point), Digits);
      }//if (StopLoss > 0) 
      
      type = OP_SELL;
      price = Bid;
      SendTrade = true;      
   }//if (SendShort)
   

   if (SendTrade)
   {
      bool result = SendSingleTrade(type, TradeComment, SendLots, price, stop, take);
   }//if (SendTrade)
   
   //Actions when trade send succeeds
   if (SendTrade && result)
   {
      if (HiddenPips > 0) ReplaceMissingSlTpLines();
   }//if (result)
   
   //Actions when trade send fails
   if (SendTrade && !result)
   {
   
   }//if (!result)
   
   

}//void LookForTradingOpportunities()

bool CloseTrade(int ticket)
{   
   while(IsTradeContextBusy()) Sleep(100);
   bool result = OrderClose(ticket, OrderLots(), OrderClosePrice(), 1000, CLR_NONE);

   //Actions when trade send succeeds
   if (result)
   {
      return(true);
   }//if (result)
   
   //Actions when trade send fails
   if (!result)
   {
      return(false);
   }//if (!result)
   

}//End bool CloseTrade(ticket)

////////////////////////////////////////////////////////////////////////////////////////////////
//Indicator module

void CalculateDailyResult()
{
   //Calculate the no of winners and losers from today's trading. These are held in the history tab.

   LossTrades = 0;
   WinTrades = 0;
   OverallProfit = 0;
   
   int tot = OrdersHistoryTotal();
   if (tot == 0) return;
   
   for (int cc = 0; cc <= tot; cc++)
   {
      if (!OrderSelect(cc, SELECT_BY_POS, MODE_HISTORY) ) continue;
      if (OrderSymbol() != Symbol() ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      
      OverallProfit+= (OrderProfit() + OrderSwap() + OrderCommission() );
      if (OrderProfit() > 0) WinTrades++;
      if (OrderProfit() < 0) LossTrades++;      
   }//for (int cc = 0; cc <= tot -1; cc++)

}//End void CalculateDailyResult()

double GetAa(int tf, int price, int period, int mashift, int method, int buffer, int shift)
{

   return(iCustom(NULL, 0, "AllAverages_v2.1 cc", tf, price, period, mashift, method, buffer, shift));

}//End double GetAa(int tf, int price, int period, int mashift, int method, int buffer, int shift)


void ReadIndicatorValues()
{
   //This function detects an up or down signal on both BB indi settings, and sets 'SlowTrend' && 'FastTrend' accordingly
   SlowTrend = none;
   FastTrend = none;
   
   
   //SlowTrend will trigger the initial trade
   //Buffer 2 holds an up signal
   SlowUpTrendSignal = iCustom(NULL, 0, "BBands_Stop_v2_2.0", SlowLength, SlowDeviation, MoneyRisk, Signal, Line, Nbars, 2, 1);
   if (SlowUpTrendSignal > -1)
   {
      SlowTrend = up;
   }//if (SlowUpTrendSignal > -1)
   
   
   //Buffer 3 holds a down signal
   SlowDownTrendSignal = iCustom(NULL, 0, "BBands_Stop_v2_2.0", SlowLength, SlowDeviation, MoneyRisk, Signal, Line, Nbars, 3, 1);
   if (SlowDownTrendSignal > -1) SlowTrend = down;



   //FastTrend will trigger one of the two secondary trades, if there is already a primary in place
   //Buffer 2 holds an up signal
   //FastLength = 0 disables this filter
   if (FastLength > 0)
   {
      FastUpTrendSignal = iCustom(NULL, 0, "BBands_Stop_v2_2.0", FastLength, FastDeviation, MoneyRisk, Signal, Line, Nbars, 2, 1);
      if (FastUpTrendSignal > -1)
      {
         FastTrend = up;
         return;
      }//if (FastUpTrendSignal > -1)
   
   
      //Buffer 3 holds a down signal
      FastDownTrendSignal = iCustom(NULL, 0, "BBands_Stop_v2_2.0", FastLength, FastDeviation, MoneyRisk, Signal, Line, Nbars, 3, 1);
      if (FastDownTrendSignal > -1) FastTrend = down;
   }//if (FastLength > 0)
   
   //If SlowTrend has detected a signal, then check AA if the user requires this
   if (UseAA)
   {
      //AaVal = GetAa(TimeFrame, Price, MA_Period, MA_Shift, MA_Method, 0, CandleShift);
      AaUp = GetAa(TimeFrame, Price, MA_Period, MA_Shift, MA_Method, 1, CandleShift);//Up buffer
      AaDown = GetAa(TimeFrame, Price, MA_Period, MA_Shift, MA_Method, 3, CandleShift);//Down buffer

      if (AaUp != EMPTY_VALUE) AaDirection = up;
      if (AaDown != EMPTY_VALUE) AaDirection = down;
      if (AaUp != EMPTY_VALUE && AaDown != EMPTY_VALUE) AaDirection = both;//Happens at the turn      
   }//if (UseAA)

   
}//void ReadIndicatorValues()

//End Indicator module
////////////////////////////////////////////////////////////////////////////////////////////////

void LookForTradeClosure()
{
   //Close the trade if the close conditions are met
   if (!OrderSelect(TicketNo, SELECT_BY_TICKET) ) return;
   if (OrderSelect(TicketNo, SELECT_BY_TICKET) && OrderCloseTime() > 0) return;
   
   bool CloseTrade;
   
   string LineName = TpPrefix + DoubleToStr(TicketNo, 0);
   //Work with the lines on the chart that represent the hidden tp/sl
   double take = ObjectGet(LineName, OBJPROP_PRICE1);
   LineName = SlPrefix + DoubleToStr(TicketNo, 0);
   double stop = ObjectGet(LineName, OBJPROP_PRICE1);
   
   if (OrderType() == OP_BUY)
   {
      //TP
      if (Bid >= take && take > 0) CloseTrade = true;
      //SL
      if (Bid <= stop && stop > 0) CloseTrade = true;

   }//if (OrderType() == OP_BUY)
   
   
   if (OrderType() == OP_SELL)
   {
      //TP
      if (Bid <= take && take > 0) CloseTrade = true;
      //SL
      if (Bid >= stop && stop > 0) CloseTrade = true;

   }//if (OrderType() == OP_SELL)
   
   if (CloseTrade)
   {
      bool result = CloseTrade(TicketNo);
      //Actions when trade send succeeds
      if (result)
      {
         DeletePendingPriceLines();
      }//if (result)
   
      //Actions when trade send fails
      if (!result)
      {
   
      }//if (!result)
   

   }//if (CloseTrade)
   
   
}//void LookForTradeClosure()

void CloseAllTrades()
{
   ForceTradeClosure = false;
   
   if (OrdersTotal() == 0) return;
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() != Symbol() ) continue;
      while(IsTradeContextBusy()) Sleep(100);
      if (OrderType() == OP_BUY || OrderType() == OP_SELL) bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 1000, CLR_NONE);
      if (result) cc++;
      if (!result) ForceTradeClosure= true;      
   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)

   if (!ForceTradeClosure) 
   {
      OpenTrades = 0;
      BuyOpen = false;
      SellOpen = false;
   }//if (!ForceTradeClosure) 
   
}//End void CloseAllTrades()


bool CheckTradingTimes()
{
   int hour = TimeHour(TimeLocal() );
   
   if (end_hourm < start_hourm)
	{
		end_hourm += 24;
	}
	

	if (end_houre < start_houre)
	{
		end_houre += 24;
	}
	
	bool ok2Trade = true;
	
	ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);

	// adjust for past-end-of-day cases
	// eg in AUS, USDJPY trades 09-17 and 22-06
	// so, the above check failed, check if it is because of this condition
	if (!ok2Trade && hour < 12)
	{
 		hour += 24;
		ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);		
		// so, if the trading hours are 11pm - 6am and the time is between  midnight to 11am, (say, 5am)
		// the above code will result in comparing 5+24 to see if it is between 23 (11pm) and 30(6+24), which it is...
	}


   // check for end of day by looking at *both* end-hours

   if (hour >= MathMax(end_hourm, end_houre))
   {      
      ok2Trade = false;
   }//if (hour >= MathMax(end_hourm, end_houre))

   return(ok2Trade);

}//bool CheckTradingTimes()

void CountOpenTrades()
{
   OpenTrades = 0;
   TicketNo = -1;
   BuyOpen = false;
   SellOpen = false;
   upl = 0;

   if (OrdersTotal() == 0) return;
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
         OpenTrades++;
         if (TicketNo  == -1) TicketNo = OrderTicket();  
         upl+= (OrderProfit() + OrderSwap() + OrderCommission()); 
         if (OrderType() == OP_BUY) BuyOpen = true;
         if (OrderType() == OP_SELL) SellOpen = true;
         //Replace missing tp and sl lines
         if (HiddenPips > 0) ReplaceMissingSlTpLines();
         //Check for possible trade closure and order management
         if (!HedgingInProgress)
         {
            if (HiddenPips > 0) LookForTradeClosure();         
            if (OrderProfit() > 0) TradeManagementModule();
         }//if (!HedgingInProgress)
         
      }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
   }//for (int cc = OrdersTotal() - 1; cc <= 0; cc--)
   
   if (BuyOpen && SellOpen) HedgingInProgress = true;
   
}//End void CountOpenTrades();

//=============================================================================
//                           O_R_CheckForHistory()
//
//  This function is to work around a very annoying and dangerous bug in MT4:
//      immediately after you send a trade, the trade may NOT show up in the
//      order history, even though it exists according to ticket number.
//      As a result, EA's which count history to check for trade entries
//      may give many multiple entries, possibly blowing your account!
//
//  This function will take a ticket number and loop until
//  it is seen in the history.
//
//  RETURN VALUE:
//     TRUE if successful, FALSE otherwise
//
//
//  FEATURES:
//     * Re-trying under some error conditions, sleeping a random
//       time defined by an exponential probability distribution.
//
//     * Displays various error messages on the log for debugging.
//
//  ORIGINAL AUTHOR AND DATE:
//     Matt Kennel, 2010
//
//=============================================================================
bool O_R_CheckForHistory(int ticket)
{
   //My thanks to Matt for this code. He also has the undying gratitude of all users of my trading robots
   
   int lastTicket = OrderTicket();

   int cnt = 0;
   int err = GetLastError(); // so we clear the global variable.
   err = 0;
   bool exit_loop = false;
   bool success=false;

   while (!exit_loop) {
      /* loop through open trades */
      int total=OrdersTotal();
      for(int c = 0; c < total; c++) {
         if(OrderSelect(c,SELECT_BY_POS,MODE_TRADES) == true) {
            if (OrderTicket() == ticket) {
               success = true;
               exit_loop = true;
            }
         }
      }
      if (cnt > 3) {
         /* look through history too, as order may have opened and closed immediately */
         total=OrdersHistoryTotal();
         for(c = 0; c < total; c++) {
            if(OrderSelect(c,SELECT_BY_POS,MODE_HISTORY) == true) {
               if (OrderTicket() == ticket) {
                  success = true;
                  exit_loop = true;
               }
            }
         }
      }

      cnt = cnt+1;
      if (cnt > O_R_Setting_max_retries) {
         exit_loop = true;
      }
      if (!(success || exit_loop)) {
         Print("Did not find #"+ticket+" in history, sleeping, then doing retry #"+cnt);
         O_R_Sleep(O_R_Setting_sleep_time, O_R_Setting_sleep_max);
      }
   }
   // Select back the prior ticket num in case caller was using it.
   if (lastTicket >= 0) {
      OrderSelect(lastTicket, SELECT_BY_TICKET, MODE_TRADES);
   }
   if (!success) {
      Print("Never found #"+ticket+" in history! crap!");
   }
   return(success);
}//End bool O_R_CheckForHistory(int ticket)

//=============================================================================
//                              O_R_Sleep()
//
//  This sleeps a random amount of time defined by an exponential
//  probability distribution. The mean time, in Seconds is given
//  in 'mean_time'.
//  This returns immediately if we are backtesting
//  and does not sleep.
//
//=============================================================================
void O_R_Sleep(double mean_time, double max_time)
{
   if (IsTesting()) {
      return;   // return immediately if backtesting.
   }

   double p = (MathRand()+1) / 32768.0;
   double t = -MathLog(p)*mean_time;
   t = MathMin(t,max_time);
   int ms = t*1000;
   if (ms < 10) {
      ms=10;
   }
   Sleep(ms);
}//End void O_R_Sleep(double mean_time, double max_time)


///////////////////////////////////////////////////////////////////////////////////////////////////////
//Pending trade price lines module.
//Doubles up by providing missing lines for the stealth stuff
void DrawPendingPriceLines()
{
   //This function will work for a full pending-trade EA.
   //The pending tp/sl can be used for hiding the stops in a market-trading ea
   
   /*
   ObjectDelete(pendingpriceline);
   ObjectCreate(pendingpriceline, OBJ_HLINE, 0, TimeCurrent(), PendingPrice);
   if (PendingBuy) ObjectSet(pendingpriceline, OBJPROP_COLOR, Green);
   if (PendingSell) ObjectSet(pendingpriceline, OBJPROP_COLOR, Red);
   ObjectSet(pendingpriceline, OBJPROP_WIDTH, 1);
   ObjectSet(pendingpriceline, OBJPROP_STYLE, STYLE_DASH);
   */
   string LineName = TpPrefix + DoubleToStr(TicketNo, 0);//TicketNo is set by the calling function - either CountOpenTrades or DoesTradeExist
   HiddenTakeProfit = 0;
   if (TicketNo > -1 && OrderTakeProfit() > 0)
   {
      if (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP || OrderType() == OP_BUYLIMIT)
      {
         HiddenTakeProfit = NormalizeDouble(OrderTakeProfit() - (HiddenPips * Point), Digits);
      }//if (OrderType() == OP_BUY)
      
      if (OrderType() == OP_SELL)
      {
         HiddenTakeProfit = NormalizeDouble(OrderTakeProfit() + (HiddenPips * Point), Digits);
      }//if (OrderType() == OP_BUY)      
   }//if (TicketNo > -1 && OrderTakeProfit() > 0)
   
   if (HiddenTakeProfit > 0 && ObjectFind(LineName) == -1)
   {
      ObjectDelete(LineName);
      ObjectCreate(LineName, OBJ_HLINE, 0, TimeCurrent(), HiddenTakeProfit);
      ObjectSet(LineName, OBJPROP_COLOR, Green);
      ObjectSet(LineName, OBJPROP_WIDTH, 1);
      ObjectSet(LineName, OBJPROP_STYLE, STYLE_DOT);
   }//if (HiddenTakeProfit > 0)
   
   
   LineName = SlPrefix + DoubleToStr(TicketNo, 0);//TicketNo is set by the calling function - either CountOpenTrades or DoesTradeExist
   HiddenStopLoss = 0;
   if (TicketNo > -1 && OrderStopLoss() > 0)
   {
      if (OrderType() == OP_BUY)
      {
         HiddenStopLoss = NormalizeDouble(OrderStopLoss() + (HiddenPips * Point), Digits);
      }//if (OrderType() == OP_BUY)
      
      if (OrderType() == OP_SELL || OrderType() == OP_SELLSTOP || OrderType() == OP_SELLLIMIT)
      {
         HiddenStopLoss = NormalizeDouble(OrderStopLoss() - (HiddenPips * Point), Digits);
      }//if (OrderType() == OP_BUY)      
   }//if (TicketNo > -1 && OrderStopLoss() > 0)
   
   if (HiddenStopLoss > 0 && ObjectFind(LineName) == -1)
   {
      ObjectDelete(LineName);
      ObjectCreate(LineName, OBJ_HLINE, 0, TimeCurrent(), HiddenStopLoss);
      ObjectSet(LineName, OBJPROP_COLOR, Red);
      ObjectSet(LineName, OBJPROP_WIDTH, 1);
      ObjectSet(LineName, OBJPROP_STYLE, STYLE_DOT);
   }//if (HiddenStopLoss > 0)
   
   

}//End void DrawPendingPriceLines()


void DeletePendingPriceLines()
{

   
   //ObjectDelete(pendingpriceline);
   string LineName = TpPrefix + DoubleToStr(TicketNo, 0);
   ObjectDelete(LineName);
   LineName = SlPrefix + DoubleToStr(TicketNo, 0);
   ObjectDelete(LineName);
   
}//End void DeletePendingPriceLines()

void ReplaceMissingSlTpLines()
{

   if (OrderTakeProfit() > 0 || OrderStopLoss() > 0) DrawPendingPriceLines();

}//End void ReplaceMissingSlTpLines()

void DeleteOrphanTpSlLines()
{

   if (ObjectsTotal() == 0) return;
   
   for (int cc = ObjectsTotal() - 1; cc >= 0; cc--)
   {
      string name = ObjectName(cc);
      
      if ((StringSubstr(name, 0, 2) == TpPrefix || StringSubstr(name, 0, 2) == SlPrefix) && ObjectType(name) == OBJ_HLINE)
      {
         int tn = StrToDouble(StringSubstr(name, 2));
         if (tn > 0) 
         {
            if (!OrderSelect(tn, SELECT_BY_TICKET, MODE_TRADES) || OrderCloseTime() > 0)
            {
               ObjectDelete(name);
               cc++;
            }//if (!OrderSelect(tn, SELECT_BY_TICKET, MODE_TRADES) || OrderCloseTime() > 0)
            
         }//if (tn > 0) 
         
         
      }//if (StringSubstr(name, 0, 1) == TpPrefix)
      
   }//for (int cc = ObjectsTotal() - 1; cc >= 0; cc--)
   
   
}//End void DeleteOrphanTpSlLines()


//END Pending trade price lines module
///////////////////////////////////////////////////////////////////////////////////////////////////////





////////////////////////////////////////////////////////////////////////////////////////////////
//Hanover module
void SetUpArrays()
{
   //Sets up all the arrays required by this program

   int cc;
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   

   //TimeFrames
   InputString = TimeFrames;
   CleanUpInputString();
   TimeFrames = InputString;
   NoOfTimeFrames = CalculateParamsPassed();
   string NewArray2 = ArrayResize(Tf, NoOfTimeFrames);
   
   Index = 0;//For searching InputString
   LastIndex = 0;//Points the the most recent Index
   for (cc = 0; cc < NoOfTimeFrames; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         Tf[cc] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         Tf[cc] = StringTrimLeft(Tf[cc]);
         Tf[cc] = StringTrimRight(Tf[cc]);
         LastIndex = Index+1;
      }//if (Index > -1)      
   }//for (cc = 0; cc < NoOfTimeFrames; cc ++)

   //StrongWeak
   string NewArray3 = ArrayResize(StrongWeak, NoOfTimeFrames);
   string NewArray4 = ArrayResize(StrongestCcy, NoOfTimeFrames);
   string NewArray5 = ArrayResize(WeakestCcy, NoOfTimeFrames);
   double NewArray6 = ArrayResize(StrongVal, NoOfTimeFrames);
   double NewArray7 = ArrayResize(WeakVal, NoOfTimeFrames);
   double NewArray8 = ArrayResize(PrevStrongVal, NoOfTimeFrames);
   double NewArray9 = ArrayResize(PrevWeakVal, NoOfTimeFrames);
   double NewArray10 = ArrayResize(ConstructedPair, NoOfTimeFrames);
   
   
   
   
}//End void SetUpArrays()

void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

int CalculateParamsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   int NoOfParams = 0;
   
   while(Index > -1)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         NoOfParams++;
         LastIndex = Index+1;            
      }//if (Index > -1)
   }//while(int cc > -1)
      
  return(NoOfParams);
}//int CalculateParamsPassed()


//+------------------------------------------------------------------+
string StringRight(string str, int n=1)
//+------------------------------------------------------------------+
// Returns the rightmost N characters of STR, if N is positive
// Usage:    string x=StringRight("ABCDEFG",2)  returns x = "FG"
//
// Returns all but the leftmost N characters of STR, if N is negative
// Usage:    string x=StringRight("ABCDEFG",-2)  returns x = "CDEFG"
{
  if (n > 0)  return(StringSubstr(str,StringLen(str)-n,n));
  if (n < 0)  return(StringSubstr(str,-n,StringLen(str)-n));
  return("");
}


//+------------------------------------------------------------------+
int StringFindCount(string str, string str2)
//+------------------------------------------------------------------+
// Returns the number of occurrences of STR2 in STR
// Usage:   int x = StringFindCount("ABCDEFGHIJKABACABB","AB")   returns x = 3
{
  int c = 0;
  for (int i=0; i<StringLen(str); i++)
    if (StringSubstr(str,i,StringLen(str2)) == str2)  c++;
  return(c);
}


string StringUpper(string str)
//+------------------------------------------------------------------+
// Converts any lowercase characters in a string to uppercase
// Usage:    string x=StringUpper("The Quick Brown Fox")  returns x = "THE QUICK BROWN FOX"
{
  string outstr = "";
  string lower  = "abcdefghijklmnopqrstuvwxyz";
  string upper  = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  for(int i=0; i<StringLen(str); i++)  {
    int t1 = StringFind(lower,StringSubstr(str,i,1),0);
    if (t1 >=0)  
      outstr = outstr + StringSubstr(upper,t1,1);
    else
      outstr = outstr + StringSubstr(str,i,1);
  }
  return(outstr);
}  

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
string StringTrim(string str)
//+------------------------------------------------------------------+
// Removes all spaces (leading, traing embedded) from a string
// Usage:    string x=StringUpper("The Quick Brown Fox")  returns x = "TheQuickBrownFox"
{
  string outstr = "";
  for(int i=0; i<StringLen(str); i++)  {
    if (StringSubstr(str,i,1) != " ")
      outstr = outstr + StringSubstr(str,i,1);
  }
  return(outstr);
}

//+------------------------------------------------------------------+
int StrToStringArray(string str, string &a[], string delim=",", string init="")  {
//+------------------------------------------------------------------+
// Breaks down a single string into string array 'a' (elements delimited by 'delim')
  for (int i=0; i<ArraySize(a); i++)
    a[i] = init;
  int z1=-1, z2=0;
  if (StringRight(str,1) != delim)  str = str + delim;
  for (i=0; i<ArraySize(a); i++)  {
    z2 = StringFind(str,delim,z1+1);
    a[i] = StringSubstr(str,z1+1,z2-z1-1);
    if (z2 >= StringLen(str)-1)   break;
    z1 = z2;
  }
  return(StringFindCount(str,delim));
}


//+------------------------------------------------------------------+
int ArrayLookupString(string str, string a[])   {
//+------------------------------------------------------------------+
 for (int i=0; i<ArraySize(a); i++)   {
   if (str == a[i])   return(i);
 }  
 return(-1);
} 

//+------------------------------------------------------------------+
double StrToNumber(string str)  {
//+------------------------------------------------------------------+
// Usage: strips all non-numeric characters out of a string, to return a numeric (double) value
//  valid numeric characters are digits 0,1,2,3,4,5,6,7,8,9, decimal point (.) and minus sign (-)
  int    dp   = -1;
  int    sgn  = 1;
  double num  = 0.0;
  for (int i=0; i<StringLen(str); i++)  {
    string s = StringSubstr(str,i,1);
    if (s == "-")  sgn = -sgn;   else
    if (s == ".")  dp = 0;       else
    if (s >= "0" && s <= "9")  {
      if (dp >= 0)  dp++;
      if (dp > 0)
        num = num + StrToInteger(s) / MathPow(10,dp);
      else
        num = num * 10 + StrToInteger(s);
    }
  }
  return(num*sgn);
}

int LoadRSvalues()  
{
  //This code courtesy of hanover. Many thanks David. You are a star.
  
  //Ccy[] holds the individual currency symbol
  //Tf[] holds the time frames
  //God knows where we go from here
  
  // Initialize array......
  for (i=0; i<8; i++)
    for (j=0; j<9; j++)
      for (k=0; k<99; k++)
         RSvalue[i][j][k] = 0;

         // Read data from Recent Strength export file into RSvalue array.......
         h = FileOpen(OutputFile,FILE_CSV|FILE_READ,'~');
         i=0; j=0; k=0;
         string prevtf = "";
         while (!FileIsEnding(h))     
         {
           StrToStringArray(FileReadString(h),arr);
           if (FileIsEnding(h))   break;
           if (arr[1] == "TF ")   
           {                                     // get ccy IDs from header record
             for (i=0; i<8; i++)  
             {
               ccy[i] = StringUpper(StringTrim(arr[i+3]));               
             }//for (i=0; i<8; i++)  
             continue;
           }//if (arr[1] == "TF ")   
           string currtf = StringUpper(StringTrimRight(arr[1]));
           j = ArrayLookupString(currtf,tf);
           if (j<0)     continue;                                    // unknown timeframe - should never happen
           if (currtf != prevtf)                                     // reset datapoint counter on change of timeframe
             k = 0;
           else
             k++;
           if (k>=99)   continue;                                    // max of 99 data points only
           for (i=0; i<8; i++)  
           {                                    // load array values for all currencies
             RSvalue[i][j][k] = StrToNumber(arr[i+3]);
             
           }//for (i=0; i<8; i++)  
           prevtf = currtf;  
         }//while (!FileIsEnding(h))     
  FileClose(h);
  return(0);
}//End int LoadRSvalues()  

void ReadHanover()
{
   //This function reads the output from the indi output file.
   LoadRSvalues();

/* Posted by hanover
If we use RSvalue[i][j][k], then
i = the currency
j = the timeframe
k = the datapoint#. Point #0 is rightmost point on the RS plot; point #1 is the second point from the right; 
point #2 is the third point from the right; and so on, up to the number of points being 
output (set by the NumPoints parameter in RS)

Hence, supposing you want to retrieve the value of the third datapoint for USD,H1, then (using the constants defined earlier) you could use the code:

double value = RSvalue[_USD][_H1][2];
*/
   //Find the strongest and weakest currency
   //Strongest
   double s, ps;//Strongest and previous strongest value
   double w, pw;//Weakest and previous weakest value


   //Currencies
   for (i = 0; i < ArraySize(StrongVal); i++)
   {
      StrongVal[i] = 0;//Initialize the strongest datapoint
      WeakVal[i] = 100000;//Initialize the weakest datapoint
   }//for (i = 0; i < ArraySize(StrongVal); i++)
   
   for (i = 0; i < ArraySize(ccy); i++)
   {
      //Timeframes
      for (j = 0; j < ArraySize(Tf); j++)
      {
         //Data point
         //Extract the timeframe - uses David's constants
         int DatapointTf;
         if (Tf[j] == "M1") DatapointTf = M1;
         if (Tf[j] == "M5") DatapointTf = M5;
         if (Tf[j] == "M15") DatapointTf = M15;
         if (Tf[j] == "M30") DatapointTf = M30;
         if (Tf[j] == "H1") DatapointTf = H1;
         if (Tf[j] == "H4") DatapointTf = H4;
         if (Tf[j] == "D1") DatapointTf = D1;
         if (Tf[j] == "W1") DatapointTf = W1;
         if (Tf[j] == "MN") DatapointTf = MN;
         
         for (k = 0; k < NumPoints; k++)
         {
            //Find the strongest datapoint on the current currency and timeframe
            if (RSvalue[i, DatapointTf, 0] > StrongVal[j])
            {
               StrongestCcy[j] = ccy[i];
               StrongVal[j] = RSvalue[i, DatapointTf, 0];
               PrevStrongVal[j] = RSvalue[i, DatapointTf, SlopeConfirmationCandles];
            }//if (RSvalue[i, j, k] > StrongVal[cc])
            
            //Find the seakest datapoint on the current currency and timeframe
            if (RSvalue[i, DatapointTf, 0] < WeakVal[j])
            {
               WeakestCcy[j] = ccy[i];
               WeakVal[j] = RSvalue[i, DatapointTf, 0];
               PrevWeakVal[j] = RSvalue[i, DatapointTf, SlopeConfirmationCandles];
            }//if (RSvalue[i, j, k] > StrongVal[cc])            
         }//for (k = 0; k <= NumPoints; k++)         
      }//for (j = 0; j < ArraySize(Tf); j++)
   }//for (i = 0; i < ArraySize(ccy); i++)
   //Alert("Strongest ", StrongestCcy[0], "  ", StrongVal[0], " Weakest ", WeakestCcy[0], "  ", WeakVal[0]);
   

   
   


}//End void ReadHanover()

double ReadStrength(string curr, string tf, int shift)
{
   /*
   Returns the strength of the individual currency referenced by the parameters:
      - curr is the currency
      - tf is the time frame
      - shift is how far back in time to look
   */

   //Extract the timeframe - uses David's constants
   int DatapointTf;
   if (tf == "M1") DatapointTf = M1;
   if (tf == "M5") DatapointTf = M5;
   if (tf == "M15") DatapointTf = M15;
   if (tf == "M30") DatapointTf = M30;
   if (tf == "H1") DatapointTf = H1;
   if (tf == "H4") DatapointTf = H4;
   if (tf == "D1") DatapointTf = D1;
   if (tf == "W1") DatapointTf = W1;
   if (tf == "MN") DatapointTf = MN;

   //Allign the curr param with David's constant
   int cc;
   if (curr == "AUD") cc = AUD;
   if (curr == "CAD") cc = CAD;
   if (curr == "CHF") cc = CHF;
   if (curr == "EUR") cc = EUR;
   if (curr == "GBP") cc = GBP;
   if (curr == "JPY") cc = JPY;
   if (curr == "NZD") cc = NZD;
   if (curr == "USD") cc = USD;
   
   return(RSvalue[cc, DatapointTf, shift]);
   
}//End double ReadStrength(string curr, string tf, int shift)

bool HanoverFilter(int type)
{
   //Returns true if the filter indicates sufficient strength/weakness in the pair.
   //Works by running through the tests and returning false if any of them fail. If all pass, the eventually
   //returns true.
   //Tests all fail if the two currencies have equal strength values

   //Read the strength values
   for (int cc = 0; cc < ArraySize(Tf); cc++)
   {
      //First filter. Compare the strength over the chosen time frames
      double strength1 = ReadStrength(Ccy1, Tf[cc], 0);
      double strength2 = ReadStrength(Ccy2, Tf[cc], 0);
      if (SlopeConfirmationCandles > 0) 
      {
         double prevstrength1 = ReadStrength(Ccy1, Tf[cc], SlopeConfirmationCandles);
         double prevstrength2 = ReadStrength(Ccy2, Tf[cc], SlopeConfirmationCandles);   
      }//if (SlopeCandles[cc] > 0)    

     
      //EA is looking to buy. 
      if (type == OP_BUY)
      {
         //First currency must be the strongest
         if (strength1 <= strength2) return(false);

         //Slope must be rising
         if (SlopeConfirmationCandles > 0 && prevstrength1 >= prevstrength2) return(false);
         
         //Threshold. First currency must be above StrongThreshold. Second currency must be below WeakThreshopld
         if (StrongThreshold > 0 && WeakThreshold > 0)
         {
            if (strength1 < StrongThreshold || strength2 > WeakThreshold) return(false);
         }//if (StrongThreshold > 0 && WeakThreshold > 0)
         
      }//if (type == OP_BUY)
      
      //EA is looking to sell, so first currency must be the weakest
      if (type == OP_SELL && strength1 >= strength2) return(false);
      
      //EA is looking to sell. 
      if (type == OP_SELL)
      {
         //First currency must be the weakest
         if (strength1 >= strength2) return(false);

         //Slope must be falling
         if (SlopeConfirmationCandles > 0 && prevstrength1 <= prevstrength2) return(false);
         
         //Threshold. First currency must be below WeakThreshold. Second currency must be above StrongThreshopld
         if (StrongThreshold > 0 && WeakThreshold > 0)
         {
            if (strength1 > WeakThreshold || strength2 < StrongThreshold) return(false);
         }//if (StrongThreshold > 0 && WeakThreshold > 0)

      }//if (type == OP_BUY)
      
      
         
         
         
   }//for (int cc = 0; cc < ArraySize(Tf); cc++)

   

   //Got this far, so all tests have passed.
   return(true);

}//End bool HanoverFilter()


//End Hanover module
////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////
//Central Bank Intervention module

bool CentralBankInterventionModule()
{
   /*
   Called from start() if UseCBI is enabled.
   There are two methods of detecting a violent move:
      astral:
         Monitors the TickTable array and reacts to the movement in the market being >= the Threshold.
         The circular TickTable code is provided by Carsten. Many thanks Carsten. You are a star.
      George
         Builds up an swma of the Bid and draws a line to represent that moving averages, plus optional hilo lines
         that represent the price the market has to reach in order to trigger CB intervention/heavy news status.
   Function returns true if all actions succeed or none are necessary, and false to force the bot to keep on retrying.
   I got into a bit of a tangle with the various while(some condition met, keep on looping around) snippets and kept on
   setting up infinite loops, so each of them has a max tries of 20 before forcible exit.
   */

   
   double take, stop, price, type;
   bool result;
   int tries;
   bool ThresholdPassed = false;//Set to true if the threshold is breached, so the bot knows to take action

   //astral-inspired tick table
   if (UseAstral)
   {
      //Store the latest quote in TickTable
      StoreQuote();

      if (is_filled == 0) // table not full yet, so nothing to do
      { 
         return(true);
      }//if (is_filled == 0)
   
      //Calculate the direction of the move, and whether it is big enough to trigger action
      direction = none;
      int index = (tc + 1) % TableSize;
      if (TickTable[tc] < TickTable[index] ) direction = down;
      if (TickTable[tc] > TickTable[index] ) direction = up;
      if (TickDiff > Threshold) ThresholdPassed = true; 
   }//if (UseAstral)

   //George's smma
   if (UseGeorge)
   {
      CalculateMaOfTicks();
      if (number_of_ticks < Per)
      {
         return(true);//Not enough ticks for the ma to be meaningful yet
      }//if (number_of_ticks >= Per)
      
      //Calculate the direction of the move, and whether it is big enough to trigger action
      direction = none;
      double target = ObjectGet(AverageTick, OBJPROP_PRICE1);
      if (Bid > target) direction = up;
      if (Bid < target) direction = down;
      //Look for a break of the upper trigger line
      if (direction == up)
      {
         target = ObjectGet(AverageTickUp, OBJPROP_PRICE1);
         if (Bid >= target) ThresholdPassed = true;
      }//if (direction == up)
      
      //Look for a break of the lower trigger line
      if (direction == down)
      {
         target = ObjectGet(AverageTickDn, OBJPROP_PRICE1);
         if (Bid <= target) ThresholdPassed = true;
      }//if (direction == up)
      
      
   }//if (UseGeorge)
   

   
   // table is full, now we can check for the big moves
   //ThresholdPassed tells the bot that there is a big move in progress
   //direction tells the bot whether that move is up or down      
   if (ThresholdPassed) 
   {
      TakingEmergencyAction = true;//Used in SendSingleTrade to create a mahoosive slippage allowance
      
      
      // The price difference between the latest and the first entry in
      // our table is above the threshold, so take action.

      /////////////////////////////////////////////////////////////////////////////////////////////////
      //Close trade
      if (CloseOnCBI && !TradesClosed && OpenTrades > 0)
      {
         result = false;
         if (direction == down)
         {
            tries = 0;
            while (!result)
            {
               result = CbiCloseTrades(OP_BUY);
               if (result) TradesClosed = true;
               tries++;
               if (tries == 20) return(true);
            }//while (!result)            
         }//if (direction == down)
         
         
         if (direction == up)
         {
            tries = 0;
            while (!result)
            {
               result = CbiCloseTrades(OP_SELL);
               if (result) TradesClosed = true;
               tries++;
               if (tries == 20) return(true);
            }//while (!result)            
         }//if (direction == ip)
      }//if (CloseOnCBI)
      /////////////////////////////////////////////////////////////////////////////////////////////////
      
      /////////////////////////////////////////////////////////////////////////////////////////////////
      //Hedge an existing trade
      if (HedgeOnCBI && !HedgeSent && TicketNo > -1)
      {
         result = false;
         if (direction == down)
         {
            tries = 0;
            while (!result)
            {
               result = CbiHedging(OP_BUY);//Long trades need hedging short
               if (result) HedgeSent = true;
               tries++;
               if (tries == 20) return(true);
            }//while (!result)            
         }//if (direction == down)
         
         
         if (direction == up)
         {
            tries = 0;
            while (!result)
            {
               result = CbiHedging(OP_SELL);//Short trades need hedging long
               if (result) HedgeSent = true;
               tries++;
               if (tries == 20) return(true);
            }//while (!result)            
         }//if (direction == ip)         
      }//if (HedgeOnCBI)
      /////////////////////////////////////////////////////////////////////////////////////////////////
      
      
      /////////////////////////////////////////////////////////////////////////////////////////////////
      //Take a new trade
      if (TradeOnCBI && !TradeSent)
      {         
         if (direction == up)
         {
            type = OP_BUY;
            RefreshRates();
            price = Ask;
            if (TradeOnCbiTP > 0) take = NormalizeDouble(Ask + (TradeOnCbiTP * Point), Digits);
            if (TradeOnCbiSL > 0) stop = NormalizeDouble(Ask - (TradeOnCbiSL * Point), Digits);            
         }//if (direction == up)
         
         if (direction == down)
         {
            type = OP_SELL;
            RefreshRates();
            price = Bid;
            if (TradeOnCbiTP > 0) take = NormalizeDouble(Bid - (TradeOnCbiTP * Point), Digits);
            if (TradeOnCbiSL > 0) stop = NormalizeDouble(Bid + (TradeOnCbiSL * Point), Digits);            
         }//if (direction == up)
         result = SendSingleTrade(type, TradeComment, HalfLot, price, stop, take);
         if (result) 
         {
            TradeSent = true;
         }//if (result) 
         
         if (!result) 
         {
            return(false);
         }//if (result) 
         
      }//if (TradeOnCBI)
      /////////////////////////////////////////////////////////////////////////////////////////////////
      
      
      
      
   }//if (ThresholdPassed) 
   else 
   {   
      TakingEmergencyAction = false;
      //TradeSent = false;
      //HedgeSent = false;
      TradesClosed = false;
   }//else 


   //Got this far, so everything has worked as required
   return(true);

}//End bool CentralBankInterventionModule()

void StoreQuote()
{

   //New code - see 'original code' at the end of this function
   // increment the counter
   tc += 1;
   tc = tc % TableSize;// keeps tc within TableSize
   
   // fill the current tick value into the table
   TickTable[tc] = Bid;

   if (is_filled == 0) // table not full yet
   { 
      fill_check_counter += 1;
      if (fill_check_counter == TableSize) is_filled = 1;
   }//if (is_filled == 0)
   else 
   {
      TickDiff = MathAbs(TickTable[(tc + 1) % TableSize] - TickTable[tc]) * PipMultiplier;
   }//else   
      
      
   /*
   Original code
   // increment the counter
   tc += 1;
   tc = tc % TableSize;// keeps tc within TableSize
   */

}//End void StoreQuote()

void CalculateMaOfTicks()
{
   //This code from George Heitman, or wfh2006 at FF. Cheers George.
   
      //we got an incoming tick
   number_of_ticks+=1;
   
   //make sure we have gotten at least Per ticks before displaying an average
   if (number_of_ticks >= Per) {
      sum_of_ticks -= moving_average;
      moving_average = (sum_of_ticks + Bid) / Per;
     
      if (ObjectFind(AverageTick) == -1) {
         ObjectCreate(AverageTick,OBJ_HLINE,0,0,moving_average,0);
         ObjectSet(AverageTick,OBJPROP_WIDTH,2);
         ObjectSet(AverageTick,OBJPROP_COLOR,Line_Color);

         ObjectCreate(AverageTickUp,OBJ_HLINE,0,0,moving_average,0);
         ObjectSet(AverageTickUp,OBJPROP_WIDTH,1);
         ObjectSet(AverageTickUp,OBJPROP_COLOR,Line_Color);

         ObjectCreate(AverageTickDn,OBJ_HLINE,0,0,moving_average,0);
         ObjectSet(AverageTickDn,OBJPROP_WIDTH,1);
         ObjectSet(AverageTickDn,OBJPROP_COLOR,Line_Color);
      }//if (ObjectFind(AverageTick) == -1)
      
      ObjectSet(AverageTick,OBJPROP_PRICE1,moving_average);
      ObjectSet(AverageTickUp,OBJPROP_PRICE1,moving_average+Channel_Delta * Point);
      ObjectSet(AverageTickDn,OBJPROP_PRICE1,moving_average-Channel_Delta * Point);
   }//if (number_of_ticks >= Per)
   
   sum_of_ticks += Bid;
   


}//End void CalculateMaOfTicks()


bool CbiCloseTrades(int type)
{
   bool success = true;
   
   if (OrdersTotal() == 0) return(true);
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() != Symbol() ) continue;
      while(IsTradeContextBusy()) Sleep(100);
      if (OrderType() == type) bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 1000, CLR_NONE);
      if (result) cc++;
      if (!result) success = false;      
   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   
   return(success);

}//End bool CbiCloseTrades(int type)


bool CbiHedging(int type)
{
   //Opens an opposite direction hedge trade to that of the passed param
   bool success = true;
   bool result;
   int HedgeType = OP_SELL;
   if (type == OP_SELL) HedgeType = OP_BUY;
   
   if (OrdersTotal() == 0) return(true);
   
   for (int cc = 0; cc <= OrdersTotal() - 1; cc++)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() != Symbol() ) continue;
      if (OrderType() != type) continue;
      while(IsTradeContextBusy()) Sleep(100);

      //Check to see if the trade is already hedged.
      bool hedged = IsTradeAlreadyHedged(cc);
      if (hedged) 
      {
         //TicketNo is set in CountOpenTrades(). Reset the selected trade in case the intervening code leaves it unselected.
         OrderSelect(TicketNo, SELECT_BY_TICKET, MODE_TRADES);         
      }//if (IsTradeAlreadyHedged(index)) 

      if (!hedged)
      {
         if (OrderType() == type) result = SetupHedgeTrade(HedgeType);
         if (!result) success = false;      
      }//if (!hedged)
      
   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   
   return(success);



}//End bool CbiHedging(int type)

bool SetupHedgeTrade(int type)
{
   //Order that needs hedging is already selected. This function sets up and sends the hedge trade
   
   bool result = false;
   int tries = 0;
   double SendLots;
   double price;

   SendLots = OrderLots() * CbiHedgeLotMultiplier;
   
   
   
   if (type == OP_SELL) 
   {
      //Check the trade does need hedging
      if (OrderProfit() > 0 && OrderStopLoss() > OrderOpenPrice() ) return(true);//No need to hedge a safe trade
      RefreshRates();
      price = Bid;
   }//if (type == OP_SELL) 
   
   if (type == OP_BUY) 
   {
      //Check the trade does need hedging
      if (OrderProfit() > 0 && OrderStopLoss() < OrderOpenPrice() ) return(true);//No need to hedge a safe trade
      RefreshRates();
      price = Ask;
   }//if (type == OP_BUY) 
   
   while (IsTradeContextBusy() ) Sleep(100);
   int tn = OrderTicket();//Need this to reselect the trade to remove the tp and sl from the trade
   while (!result)
   {
      result = SendSingleTrade(type, TradeComment, SendLots, price, 0, 0);
      //Remove existing tp/sl from the hedged trade. I will tidy this up later
      if (result) 
      {
         HedgingInProgress = true;
         OrderSelect(tn, SELECT_BY_TICKET);
         
         if (OrderTakeProfit() > 0) 
         {
            while (IsTradeContextBusy() ) Sleep(100);            
            OrderModify(tn, OrderOpenPrice(), OrderStopLoss(), 0, OrderExpiration(), CLR_NONE);
         }//if (OrderTakeProfit() > 0) 
         
         if (OrderStopLoss() > 0) 
         {
            while (IsTradeContextBusy() ) Sleep(100);            
            OrderModify(tn, OrderOpenPrice(), 0, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
         }//if (OrderTakeProfit() > 0) 
         
         
         
      }//if (result) 
      
      tries++;
      if (tries == 20) result = true;      
   }//while (!result)
   
   
   return(result);
   
}//bool SetupHedgeTrade()

bool IsTradeAlreadyHedged(int index)
{

   /*
   Trade will already be hedged if:
      - there is an opposite direction trade open
      - the opp trade has a lot size x HedgeLotsMultiplier
   */
   
   //Alread at the end of the trade loop?
   if (index == OrdersTotal() - 1) return(false);
   
   //Need to know the order type and lot size
   int type = OrderType();
   double LotSize = OrderLots();
   
   //Loop through the remaining trades to find a hedge. Reselect original trade and teturn true if found
   for (int cc = index + 1; cc < OrdersTotal(); cc++)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderSymbol() != Symbol() ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      
      //All EA belonging conditions satisfied, so examine the trades
      if (type == OP_BUY && OrderType() == OP_SELL && OrderLots() == LotSize * CbiHedgeLotMultiplier) 
      {
         //TicketNo is set in CountOpenTrades(). Reset the selected trade.
         OrderSelect(TicketNo, SELECT_BY_TICKET, MODE_TRADES);   
         return(true);//Is a hedge
      }//if (type == OP_BUY && OrderType() == OP_SELL && OrderLots() == LotSize * 2) 
      
      if (type == OP_SELL && OrderType() == OP_BUY && OrderLots() == LotSize * CbiHedgeLotMultiplier) 
      {
         //TicketNo is set in CountOpenTrades(). Reset the selected trade.
         OrderSelect(TicketNo, SELECT_BY_TICKET, MODE_TRADES);   
         return(true);//Is a hedge
      }//if (type == OP_SELL && OrderType() == OP_BUY && OrderLots() == LotSize * 2) 
      
   }//for (int cc = index + 1); cc < OrdersTotal(); cc++)
   
   
   //TicketNo is set in CountOpenTrades(). Reset the selected trade.
   OrderSelect(TicketNo, SELECT_BY_TICKET, MODE_TRADES);
   
   //Got this far, so trade is not already hedged
   return(false);

}//End bool IsTradeAlreadyHedged(int index)



//End Central Bank Intervention module
////////////////////////////////////////////////////////////////////////////////////////////////



//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

   
   if (OrdersTotal() == 0)
   {
      TicketNo = -1;
      ForceTradeClosure = false;
   }//if (OrdersTotal() == 0)

   //D1 open price line added for Swg123. Read the post at
   //http://www.forexfactory.com/showthread.php?p=5132307#post5132307 for reasons
   if (DrawOpenPriceLine && ObjectGet(d1openpriceline,OBJPROP_TIME1) != iTime(NULL, PERIOD_D1, 0) )
   {
      ObjectDelete(d1openpriceline);
      ObjectCreate(d1openpriceline,OBJ_TREND, 0, iTime(NULL, PERIOD_D1, 0), iOpen(NULL, PERIOD_D1, 0), TimeCurrent(), iOpen(NULL, PERIOD_D1, 0));
      ObjectSet(d1openpriceline,OBJPROP_COLOR,OpenPriceLineColour);
      ObjectSet(d1openpriceline,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet(d1openpriceline,OBJPROP_WIDTH,0);    
      ObjectSet(d1openpriceline,OBJPROP_RAY,true);    

      double pivot = (iHigh(NULL, PERIOD_D1, 0) + iLow(NULL, PERIOD_D1, 0) + iClose(NULL, PERIOD_D1, 0)) / 3;
      ObjectDelete(dailypivotline);
      ObjectCreate(dailypivotline,OBJ_TREND, 0, iTime(NULL, PERIOD_D1, 0), pivot, TimeCurrent(), pivot);
      ObjectSet(dailypivotline,OBJPROP_COLOR,PivotPriceLineColour);
      ObjectSet(dailypivotline,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet(dailypivotline,OBJPROP_WIDTH,0);    
      ObjectSet(dailypivotline,OBJPROP_RAY,true);    
      
   }//if (DrawOpenPriceLine && iTime(NULL, PERIOD_D1, 0) != D1OpenTime)
//dailypivotline   
 //extern bool    DrawPivotPriceLine=true;
//extern color   PivotPriceLineColour=Turquoise;
  
   //Central Bank Intervention module
   if (UseCBI) 
   {
      int tries;
      bool ok = false;
      while (!ok)
      {
         ok = CentralBankInterventionModule();         
         tries++;
         if (tries == 20) ok = true;
      }//while (!ok)         
   }//if (UseCBI) 

   if (ForceTradeClosure) 
   {
      CloseAllTrades();
      return;
   }//if (ForceTradeClosure) 

   
   if (UseHanover)
   {
      //Read the indi once a minute
      if (ReadBars != iBars(NULL, PERIOD_M1) && UseHanover)
      {
         ReadBars = iBars(NULL, PERIOD_M1);
         ReadHanover();
      }//if (ReadBars != iBars(NULL, PERIOD_M1)
   }//if (UseHanover)
   
   static int OldTime;
   if (iTime(NULL, PERIOD_M1, 0) != OldTime)
   {
      CalculateDailyResult();//Does no harm to have a recalc from time to time
      OldTime = iTime(NULL, PERIOD_M1, 0);
   }//if (iTime(NULL, PERIOD_M1, 0) != OldTime)

   ReadIndicatorValues();

   //Delete orphaned tp/sl lines
   static int M15Bars;
   if (M15Bars != iBars(NULL, PERIOD_M15) )
   {
      M15Bars = iBars(NULL, PERIOD_M15);
      DeleteOrphanTpSlLines();
   }//if (M15Bars != iBars(NULL, PERIOD_M15)
   
      
   ///////////////////////////////////////////////////////////////////////////////////////////////
   //Find open trades.
   CountOpenTrades();

   //Reset the CBI bools
   if (OpenTrades == 0)
   {
      TakingEmergencyAction = false;
      TradeSent = false;
      HedgeSent = false;
      TradesClosed = false;
   }//if (OpenTrades > 0)


   //Hedging. This might need removing
   if (HedgingInProgress)
   {
      if (upl >= 0) 
      {
         CloseAllTrades();
      }//if (upl <= HedgeStopLoss && HedgeStopLoss != 0) 
      
      if (ForceTradeClosure) return;
   }//if (UseHedging)

      
 
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Trading times
   bool TradeTimeOk = CheckTradingTimes();
   if (!TradeTimeOk)
   {
      Comment("Outside trading hours\nstart_hourm-end_hourm: ", start_hourm, "-",end_hourm, "\nstart_houre-end_houre: ", start_houre, "-",end_houre);
      return;
   }//if (hour < start_hourm)
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////

   ///////////////////////////////////////////////////////////////////////////////////////////////         
   //Trading
   if (OldBars != Bars)
   {   
      OldBars = Bars;
      ReadIndicatorValues();
      
      //Close opposite direction trades on a SlowTrend change
      if (SlowTrend == up && SellOpen && !HedgingInProgress && CloseTradeOnOppositeSignal)
      {
         CloseAllTrades();
         if (ForceTradeClosure) 
         {
            CloseAllTrades();
            OldBars = 0;
            return;
         }//if (ForceTradeClosure) 
      }//if (SlowTrend == up && BuyOpen)

      //Close opposite direction trades on a FastTrend change - GAH
      if (FastTrend == up && SellOpen && !HedgingInProgress && CloseTradeOnFastTrendChange)
      {
         CloseAllTrades();
         if (ForceTradeClosure) 
         {
            CloseAllTrades();
            OldBars = 0;
            return;
         }//if (ForceTradeClosure) 
      }//if (SlowTrend == up && BuyOpen)
      
      
      if (SlowTrend == down && BuyOpen && !HedgingInProgress && CloseTradeOnOppositeSignal)
      {
         CloseAllTrades();
         if (ForceTradeClosure) 
         {
            CloseAllTrades();
            OldBars = 0;
            return;
         }//if (ForceTradeClosure) 
      }//if (SlowTrend == up && BuyOpen)


      //Close opposite direction trades on a FastTrend change - GAH
      if (FastTrend == down && BuyOpen && !HedgingInProgress && CloseTradeOnFastTrendChange)
      {
         CloseAllTrades();
         if (ForceTradeClosure) 
         {
            CloseAllTrades();
            OldBars = 0;
            return;
         }//if (ForceTradeClosure) 
      }//if (SlowTrend == up && BuyOpen)
      
      
      if (!StopTrading)
      {
         LookForTradingOpportunities();
      }//if (TicketNo == -1)
   }//if (OldBars != Bars)
   
   ///////////////////////////////////////////////////////////////////////////////////////////////      

   DisplayUserFeedback();
   
//----
   return(0);
}
//+------------------------------------------------------------------+